SystemOrganization addCategory: #'Magritte-Pharo-Tools'!

ORCmdMethodRefactoring subclass: #ORCmdMagritteDescriptionUpdate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Pharo-Tools'!

!ORCmdMagritteDescriptionUpdate methodsFor: 'accessing' stamp: 'NickAger 1/16/2012 10:48'!
label
	^ 'Update Magritte description'! !

!ORCmdMagritteDescriptionUpdate methodsFor: 'accessing' stamp: 'NickAger 1/16/2012 10:28'!
longDescription
	^ 'Move Magritte description to instance side and convert to use pragmas.'! !

!ORCmdMagritteDescriptionUpdate methodsFor: 'accessing' stamp: 'NickAger 1/16/2012 10:55'!
refactoring
	^ MAMethodRefactoring
		model: self model
		swapMethod: self currentNode selector
		in: self currentNode theClass! !

ORSwapMethodRefactoring subclass: #MAMethodRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Pharo-Tools'!

!MAMethodRefactoring methodsFor: 'private' stamp: 'NickAger 1/13/2012 20:53'!
alreadyIncludesMagritteSelectors: parseTree
	^ (parseTree pragmas detect: [ :each | MAPragmaBuilder magritteSelectors includes: each selector ] ifNone: [ nil ]) notNil! !

!MAMethodRefactoring methodsFor: 'private' stamp: 'NickAger 1/16/2012 17:26'!
createPragma
	((selector = #descriptionContainer) or: [ selector isDescriptionExtension: #descriptionContainer ]) ifTrue: [
		^ RBPragmaNode selectorParts: (Array with: MAPragmaBuilder containerPragma) arguments: #() ].
	
	(selector isDescriptionDefinition) ifTrue: [
		^ RBPragmaNode selectorParts: (Array with: MAPragmaBuilder magritteDescriptionPragma) arguments: #() ].
	
	((selector isDescriptionSelector) and: [ selector numArgs = 1 ]) ifTrue: [
		| descriptionDefinitionSelector |
		
		descriptionDefinitionSelector := class allSelectors detect: [ :each | 
			each isDescriptionDefinition and: [ selector isDescriptionExtension: each ] ] ifNone: [ nil ].
		
		descriptionDefinitionSelector isNil ifTrue: [
			descriptionDefinitionSelector := class soleInstance allSelectors detect: [ :each | 
				each isDescriptionDefinition and: [ selector isDescriptionExtension: each ] ] ifNone: [ nil ] ].
		
		descriptionDefinitionSelector notNil ifTrue: [
			^ RBPragmaNode selectorParts: (Array with: MAPragmaBuilder magritteDescriptionExtensionPragma) arguments: (Array with: (RBLiteralValueNode literalToken: descriptionDefinitionSelector))] ].
	^ nil
! !

!MAMethodRefactoring methodsFor: 'preconditions' stamp: 'NickAger 1/13/2012 17:56'!
preconditions
	^ RBCondition withBlock: [ selector isDescriptionSelector ]! !

!MAMethodRefactoring methodsFor: 'transforming' stamp: 'NickAger 1/17/2012 16:49'!
transform
	| parseTree methodBody category |

	parseTree := class parseTreeFor: selector.
	
	(self alreadyIncludesMagritteSelectors: parseTree) ifFalse: [
		| pragma |
		pragma := self createPragma.
		pragma notNil ifTrue: [
			parseTree pragmas: (parseTree pragmas, (Array with: pragma)) ] ].
	
	category := class realClass organization categoryOfElement: selector.
	
	methodBody := class methodFor: selector.
	target compile: (parseTree formattedCode) classified: category.
	class removeMethod: selector! !

!Symbol methodsFor: '*magritte-pharo-tools' stamp: 'NickAger 1/30/2012 17:05'!
isDescriptionDefinition
	"Answer wheter the receiver is a method selector following the naming conventions of a description definition."

	^ self isDescriptionSelector
		and: [ self isUnary ]! !

!Symbol methodsFor: '*magritte-pharo-tools' stamp: 'NickAger 1/30/2012 17:05'!
isDescriptionExtension: aSelector
	"Answer wheter the receiver is a method selector following the naming conventions of a description extension to aSelector."

	^ self isDescriptionSelector
		and: [ self numArgs = 1
		and: [ self beginsWith: aSelector ] ]! !

!Symbol methodsFor: '*magritte-pharo-tools' stamp: 'NickAger 1/30/2012 17:06'!
isDescriptionSelector
	"Answer wheter the receiver is a method selector following the naming conventions of a  description selector."

	^ self ~= #description
		and: [ self beginsWith: #description ]! !

ORCmdRefactoring subclass: #ORCmdMagritteDescriptionsPackageUpdate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Pharo-Tools'!

!ORCmdMagritteDescriptionsPackageUpdate methodsFor: 'accessing' stamp: 'NickAger 1/16/2012 12:41'!
cluster
	^ #Refactor! !

!ORCmdMagritteDescriptionsPackageUpdate methodsFor: 'accessing' stamp: 'NickAger 1/16/2012 12:33'!
group
	^ #open! !

!ORCmdMagritteDescriptionsPackageUpdate methodsFor: 'testing' stamp: 'NickAger 1/16/2012 11:45'!
isActive
	^ super isActive and: [ self currentNode isKindOf: OBClassCategoryNode ]! !

!ORCmdMagritteDescriptionsPackageUpdate methodsFor: 'accessing' stamp: 'NickAger 1/16/2012 11:45'!
label
	^ 'Update Magritte descriptions'! !

!ORCmdMagritteDescriptionsPackageUpdate methodsFor: 'accessing' stamp: 'NickAger 1/16/2012 10:49'!
longDescription
	^ 'Move Magritte descriptions to instance side and convert to use pragmas.'! !

!ORCmdMagritteDescriptionsPackageUpdate methodsFor: 'accessing' stamp: 'NickAger 1/16/2012 12:29'!
refactoring
	^ MAPackageRefactoring model: self model classes: (self currentNode classes collect: [ :each | each theClass name ])! !

ORCmdOpen subclass: #ORCmdMagritteDescriptionsPackageUpdateWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Pharo-Tools'!

!ORCmdMagritteDescriptionsPackageUpdateWrapper class methodsFor: 'instance creation' stamp: 'NickAger 1/16/2012 15:45'!
on: target for: requestor
	^ ORCmdMagritteDescriptionsPackageUpdate new setTarget: target requestor: requestor! !

RBMethodRefactoring subclass: #MADescriptionRenameRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Pharo-Tools'!

!MADescriptionRenameRefactoring class methodsFor: 'initialization' stamp: 'NickAger 1/16/2012 16:43'!
forClass: class
	^ self new
		class: class
		yourself! !

!MADescriptionRenameRefactoring methodsFor: 'accessing' stamp: 'NickAger 1/16/2012 16:45'!
class: aClass
	class := aClass! !

!MADescriptionRenameRefactoring methodsFor: 'preconditions' stamp: 'NickAger 1/16/2012 16:54'!
preconditions
	^ RBCondition empty! !

!MADescriptionRenameRefactoring methodsFor: 'transforming' stamp: 'NickAger 1/16/2012 16:53'!
transform
	| selector target parseTree |
	parseTree := class parseTreeFor: #description.
	parseTree selector: #magritteDescription.
	class compile: (parseTree formattedCode) classified: 'acessing-magritte'.
	class removeMethod: #description.! !

ORCmdClassRefactoring subclass: #ORCmdMagritteDescriptionsClassUpdate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Pharo-Tools'!

!ORCmdMagritteDescriptionsClassUpdate methodsFor: 'accessing' stamp: 'NickAger 1/16/2012 11:46'!
label
	^ 'Update Magritte descriptions'! !

!ORCmdMagritteDescriptionsClassUpdate methodsFor: 'accessing' stamp: 'NickAger 1/16/2012 10:28'!
longDescription
	^ 'Move Magritte descriptions to instance side and convert to use pragmas.'! !

!ORCmdMagritteDescriptionsClassUpdate methodsFor: 'accessing' stamp: 'NickAger 1/16/2012 10:54'!
refactoring
	^ MAClassRefactoring model: self model className: self currentNode theClass name! !

RBClassRefactoring subclass: #MAClassRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Pharo-Tools'!

!MAClassRefactoring methodsFor: 'transforming' stamp: 'NickAger 1/16/2012 16:47'!
descriptionMethodRename
	| class |
	class := self classObjectFor: className asSymbol.
	(class selectors detect: [ :each | each = #description ] ifNone: [ nil ]) notNil ifTrue: [
		self performComponentRefactoring: (MADescriptionRenameRefactoring forClass: class) ]! !

!MAClassRefactoring methodsFor: 'preconditions' stamp: 'NickAger 1/14/2012 09:38'!
preconditions
	^ RBCondition empty! !

!MAClassRefactoring methodsFor: 'accessing' stamp: 'NickAger 1/16/2012 16:18'!
refactorings
	| class |
	class := self theClass.
	^  class selectors select: #isDescriptionSelector thenCollect: [ :each |
			MAMethodRefactoring
				model: self model
				swapMethod: each
				in: class ]! !

!MAClassRefactoring methodsFor: 'accessing' stamp: 'NickAger 1/16/2012 16:17'!
theClass
	| class |
	class := self classObjectFor: className asSymbol.
	^ class isMeta ifFalse: [ class theMetaClass ] ifTrue: [ class ]! !

!MAClassRefactoring methodsFor: 'transforming' stamp: 'NickAger 1/16/2012 16:53'!
transform
	self descriptionMethodRename.
	self refactorings do: [ :each | self performComponentRefactoring: each ]! !

RBRefactoring subclass: #MAPackageRefactoring
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Pharo-Tools'!

!MAPackageRefactoring class methodsFor: 'initialization' stamp: 'NickAger 1/16/2012 12:19'!
model: model classes: classes
	^  self new
		model: model;
		classes: classes;
		yourself! !

!MAPackageRefactoring methodsFor: 'accessing' stamp: 'NickAger 1/16/2012 13:28'!
classes
	^ classes! !

!MAPackageRefactoring methodsFor: 'accessing' stamp: 'NickAger 1/16/2012 12:20'!
classes: anObject
	classes := anObject! !

!MAPackageRefactoring methodsFor: 'preconditions' stamp: 'NickAger 1/16/2012 12:23'!
preconditions
	^ RBCondition empty! !

!MAPackageRefactoring methodsFor: 'transforming' stamp: 'NickAger 1/16/2012 12:28'!
transform
	self classes 
		collect: [ :each | MAClassRefactoring model: self model className: each ]
		thenDo: [ :each | self performComponentRefactoring: each ]! !
